/*****************************************************
 * $Workfile::                                       
 * $Author::	RJolly                                         
 * $Date::    	11/16/11                                       
 * $Revision::   	002                                    
 *
 * Copyright Stereovision, Inc. 2011
 *
 * This header files defines the input/output
 *	11/16/11	Created this file from Digital Video Recorder
		
******************************************************/
`ifndef _TOP_DEFINE
 `define _TOP_DEFINE

// Microcontroller Commands
// Received Commands
 `define START_RECORD_CMD		8'h01
 `define SET_TOTAL_SEC			8'h02
 `define SET_SEC_START_ADDR		8'h03
 `define SET_MODE				8'h04
 `define AVI_END_OF_FILE		8'h05
// Non Data Responses
 `define CLUSTER_DONE_CMD		8'h0A
 `define IMAGE_DONE_CMD			8'h0B
 `define INVALID_CMD			8'h0C
 `define AVI_DONE_CMD			8'h0D
 `define AUDIO_DONE_CMD			8'h0E

 `define JPEG_MODE			0
 `define AVI_MODE				1

// SPI Commands
 `define CMD24_WR_SINGLE_BLK		8'h58
 `define CMD25_WRITE_MULT_BLOCK	8'h59	
 `define TOKEN_WR_SINGLE_BLK		8'hFE
 `define TOKEN_RD_SINGLE_BLK		8'hFE
 `define TOKEN_MULT_BLOCK_WRITE	8'hFC
 `define TOKEN_STOP_TRAN		8'hFD
 `define DATA_ACCEPTED			8'h05

// FPGA SPI Commands
 `define WR_SPI_BYTE			4'h1
 `define RD_SPI_BYTE			4'h2
 `define WR_SPI_DATA			4'h3
 `define PROGRAM_END			4'h4

 //Counter values for automated write byte to UART
`ifdef SIM
 `define START_AUTO_WRITE			26'h1000
 `define AUTO_WRITE_IDLE			26'h1010 
 `define AUTO_WRITE_RESET_COUNT		26'h3000
`else
 `define START_AUTO_WRITE			26'h3ef1480
 `define AUTO_WRITE_IDLE			26'h3ef1490 
 `define AUTO_WRITE_RESET_COUNT		26'h3ef2e48
`endif



 `define TX_PAYLOAD_BYTES		4
 `define RX_PAYLOAD_BYTES		4


// From Xilinx Memory Controller
 `define ADDR_MSB                        31
 `define DATA_MSB                        31
 `define CYCLE                           10
 `define CYCLE_10                        50
 `define CYCLE_20                        50
 `define CYCLE_33                        30
 `define CYCLE_66                        7.5
 `define CYCLE_50                        20
 `define CYCLE_96                        5.2
 `define CYCLE_100                       5
 `define CYCLE_150                       3.33
 `define CYCLE_300                       1.66
 `define HALF_CYCLE `CYCLE/2

// for 50MHz CLK, 8 (add 1) clocks for 150ns
 `define WRITE_DLY_CYCLES		7
 `define WE_N_DELAY			0   // Number of cycles to delay WE_N signal
 `define WS_WE_N_DELAY			2   // Number of cycles to delay WE_N signal
 `define WRITE_DATA_DLY			7 // Number of cycles to delay writing data



`endif //  `ifndef _TOP_DEFINE

